//-----------------------------------------------------------------------------
//    Ufw_Apt_Efcb_1.java
//-----------------------------------------------------------------------------

package uicc.usim.test.usatframework.ufw_apt_efcb;

import uicc.toolkit.*;
import uicc.usim.test.util.*;
import javacard.framework.*;


/**
 *
 * Applet is triggered on Install (Install)
 *
 *
 */
public class Ufw_Apt_Efcb_1 extends TestToolkitApplet {
    private static boolean bRes;
    private byte testCaseNb = (byte) 0;

    /**
     * Constructor of the applet
     */
    public Ufw_Apt_Efcb_1() {
    }

    /**
     * Method called by the JCRE at the installation of the applet.
     */
    public static void install(byte[] bArray, short bOffset, byte bLength) {
        // Create a new applet instance.
        Ufw_Apt_Efcb_1 thisApplet = new Ufw_Apt_Efcb_1();

        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short) (bOffset + 1), bArray[bOffset]);

        // Initialise the data of the test applet.
        thisApplet.init();

        thisApplet.obReg.setEvent(EVENT_FORMATTED_SMS_PP_ENV);
        thisApplet.obReg.setEvent(EVENT_FORMATTED_SMS_CB);

        bRes = thisApplet.obReg.isEventSet(EVENT_FORMATTED_SMS_CB);
    }

    public void processToolkit(short event) {
        if (event == EVENT_FORMATTED_SMS_CB) {
            switch (testCaseNb) {
            case 0:

                //TEST CASE 1: Store the result of the test if the applet is registered to the event
                testCaseNb = (byte) 1;
                reportTestOutcome(testCaseNb, bRes);
                bRes = false;

                //TEST CASE 2: The applet is deregistered to the event
                testCaseNb = (byte) 2;

                try {
                    obReg.clearEvent(EVENT_FORMATTED_SMS_CB);
                    bRes = true;
                } catch (Exception e) {
                    bRes = false;
                }

                reportTestOutcome(testCaseNb, bRes);
                reportTestOutcome((byte) 3, true);

                break;

            case 2:

                //TEST CASE 3: The applet shall not be triggered in this case
                //if the applet is triggered then the test is failed
                testCaseNb = (byte) 3;
                bRes = false;
                reportTestOutcome(testCaseNb, bRes);

                break;

            case 4:

                //TEST CASE 5: The applet is triggered
                testCaseNb = (byte) 5;
                bRes = true;
                reportTestOutcome(testCaseNb, bRes);
            }
        }

        if (event == EVENT_FORMATTED_SMS_PP_ENV) {
            testCaseNb = (byte) 4;

            //TEST CASE 4: The applet is registered to the Formatted Cell BroadCast event
            try {
                obReg.setEvent(EVENT_FORMATTED_SMS_CB);
                bRes = true;
            } catch (Exception e) {
                bRes = false;
            }

            reportTestOutcome(testCaseNb, bRes);
        }
    }
}
